package com.rjconsultores.ventaboletos.web.gui.controladores.impressaofiscal;

import java.math.BigDecimal;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.api.Intbox;

import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.FiscalAliquotaEmpresa;
import com.rjconsultores.ventaboletos.exception.BusinessException;
import com.rjconsultores.ventaboletos.service.FiscalAliquotaEmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;

@Controller("editarAliquotaECFController")
@Scope("prototype")
public class EditarAliquotaECFController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private FiscalAliquotaEmpresaService fiscalAliquotaEmpresaService;

	private FiscalAliquotaEmpresa fiscalAliquotaEmpresa;
	private BusquedaAliquotaECFController busquedaAliquotaECFController;
	private MyListbox fiscalAliquotaEmpresaList;

	private Combobox cmbEmpresa;
	private List<Empresa> lsEmpresas;
	private Intbox txtTotalizador;
	private MyTextboxDecimal txtIcms;

	private Button btnApagar;
	private static Logger log = LogManager.getLogger(EditarAliquotaECFController.class);

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		fiscalAliquotaEmpresa = (FiscalAliquotaEmpresa) Executions.getCurrent().getArg().get("fiscalAliquotaEmpresa");
		fiscalAliquotaEmpresaList = (MyListbox) Executions.getCurrent().getArg().get("fiscalAliquotaEmpresaList");
		busquedaAliquotaECFController = (BusquedaAliquotaECFController) Executions.getCurrent().getArg().get("busquedaAliquotaECFController");
		lsEmpresas = UsuarioLogado.getUsuarioLogado().getEmpresa();
		if (fiscalAliquotaEmpresa.getIcms() != null) {
			if(fiscalAliquotaEmpresa.getFiscalAliquotaEmpresaId() != null){
				txtIcms.setPrecision(null);
				txtIcms.setScale(null);
			}
			txtIcms.setValue(fiscalAliquotaEmpresa.getIcms().toString().replace(".", ","));
			txtIcms.setPrecision(7);
			txtIcms.setScale(2);
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		cmbEmpresa.getValue();
		txtTotalizador.getValue();
		
		if(txtIcms.getValue() != null){
		BigDecimal icms = new BigDecimal(txtIcms.getValue().replace(",", "."));
		fiscalAliquotaEmpresa.setIcms(icms);
		}

		if (fiscalAliquotaEmpresa.getEmpresa() != null
				&& fiscalAliquotaEmpresa.getTotalizador() != null
				&& fiscalAliquotaEmpresa.getIcms() != null) {
			try {
				fiscalAliquotaEmpresaService.suscribirActualizar(fiscalAliquotaEmpresa);
			} catch (BusinessException e) {
				log.error(e);
				return;
			}
			Messagebox.show(
					Labels.getLabel("editarAliquotaECFController.MSG.suscribirOK"),
					Labels.getLabel("busquedaAliquotaECFController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			busquedaAliquotaECFController.refreshLista();
			closeWindow();
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarAliquotaECFController.MSG.borrarPergunta"),
					Labels.getLabel("editarAliquotaECFController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				fiscalAliquotaEmpresaService.borrar(fiscalAliquotaEmpresa);

				Messagebox.show(
						Labels.getLabel("editarAliquotaECFController.MSG.borrar"),
						Labels.getLabel("editarAliquotaECFController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				fiscalAliquotaEmpresaList.removeItem(fiscalAliquotaEmpresa);
				busquedaAliquotaECFController.refreshLista();
				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(Combobox cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	public Intbox getTxtTotalizador() {
		return txtTotalizador;
	}

	public void setTxtTotalizador(Intbox txtTotalizador) {
		this.txtTotalizador = txtTotalizador;
	}

	public MyTextboxDecimal getTxtIcms() {
		return txtIcms;
	}

	public void setTxtIcms(MyTextboxDecimal txtIcms) {
		this.txtIcms = txtIcms;
	}

	public FiscalAliquotaEmpresaService getFiscalAliquotaEmpresaService() {
		return fiscalAliquotaEmpresaService;
	}

	public void setFiscalAliquotaEmpresaService(FiscalAliquotaEmpresaService fiscalAliquotaEmpresaService) {
		this.fiscalAliquotaEmpresaService = fiscalAliquotaEmpresaService;
	}

	public FiscalAliquotaEmpresa getFiscalAliquotaEmpresa() {
		return fiscalAliquotaEmpresa;
	}

	public void setFiscalAliquotaEmpresa(FiscalAliquotaEmpresa fiscalAliquotaEmpresa) {
		this.fiscalAliquotaEmpresa = fiscalAliquotaEmpresa;
	}

	public MyListbox getFiscalAliquotaEmpresaList() {
		return fiscalAliquotaEmpresaList;
	}

	public void setFiscalAliquotaEmpresaList(MyListbox fiscalAliquotaEmpresaList) {
		this.fiscalAliquotaEmpresaList = fiscalAliquotaEmpresaList;
	}
}
